% Funao que permite actuar os motores atravs da carta de sinais enviando  
% tenses de acordo com as percentagens obtidas no controlo
% actua(ao,motoresq,motordto,Tis,caso)
% entradas: 
% ao--> Objecto saida analgica
% motoresq e motordir--> percentagens de energia transmitida aos motores
% esq e dto respectivamente
% Tifs--> tenses de arranque e de saturao dos motores, esq e dto
%Builded by Gonalo Madeira e Ins Faria Out2004
function actua(ao,motoresq,motordto,Tifs,caso)

%Valores limite da tensao de funcionamento do robo
Tie=Tifs(1); %arranque motor esq
Tid=Tifs(2); %arranque motor dto
Tfe=Tifs(3); %saturao esq
Tfd=Tifs(4); %saturao dto

%formulas para obter a tenso de saida atravs da percentagem de energia
%pretendida nos motores 
switch caso
    case 1
        auxe=(Tfe-Tie)*motoresq+Tie;
        auxd=(Tfd-Tid)*motordto+Tid;
    
    case 2
        auxe=(Tfe-Tie)*motoresq+Tie;
        auxd=0;
    
    case 3
        auxe=0;
        auxd=(Tfd-Tid)*motordto+Tid;
    
    case 4
        auxe=0;
        auxd=0;   
end

%teste=[auxe auxd]

% envia tensoes a carta de sinais
putdata(ao,[auxe auxd]);


start(ao);
pause(0.01)
stop(ao);
    

