%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%funcao que binariza uma imagem com base  no ponto mais escuro
%todos os pixeis com valores proximos do minimo passam a preto e os
%restantes a branco de acordo com o valor de aproximao introduzido
%[bimage] = binariza(grayimage,margem)
%Inputs
%grayimage--> imagem que se pretende binarizar
%margem--> valor dos pixeis acima do qual se pretendem transformar para pretos
%
%Outputs
%bimage--> imagem binarizada returnada
%
%Created by Gonalo Madeira e Ins Faria 2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [bimage] = binariza(grayimage,margem)

%ciclo para achar o minimo
tamanho=size(grayimage);
bimage=ones(tamanho(1),tamanho(2));
min=grayimage(1,1);
for i=1:tamanho(1),
    for j=1:tamanho(2),
        if grayimage(i,j)<min,
            min=grayimage(i,j);
        end
    end
end

%ciclo para transformar os pixeis a preto e branco
%default margem=50;
for i=1:tamanho(1),
    for j=1:tamanho(2),
        if grayimage(i,j)<min+margem,   %esta cte arredonda o min para cima para se ver mais do que meia duzia de pontos
            bimage(i,j)=0;          %quanto menor o valor menos pontos pretos se veem. No limite so se verao 
        else                        %os pontos com o valor min na matriz grayimage
            bimage(i,j)=1;
        end
    end
end

