%funao que calcula o centroide, faz o controlo e actua nos motores em
%tempo real.
% main(ao,auxBinariza,auxMargens,Tensoes,centro,props)
% Inputs:
% ao--> objecto de saida analogica
% auxbinariza--> parametro de binarizacao
% auxMargens--> parametros de controlo que estabelecem margens na imagem para o calculo das percentagens de energia 
% Tensoes--> tensoes de arranque e saturacao dos motores
% centro--> percentagem do tamanho y onde se pretende calcular a referencia de controlo
% props--> proporcoes de energia que se pretende atribuir ao controlo horizontal e vertical
%Builded by Gonalo Madeira e Ins Faria Out2004
function main(ao,auxBinariza,auxMargens,Tensoes,centro,props)


% Configure the video input object to continuously acquire data.
delete(imaqfind)
vid = videoinput('winvideo',1);
triggerconfig(vid, 'manual');
set(vid, 'Tag', 'Teste prog','TimerFcn', @capturaCallback, 'TimerPeriod',...
    0.01,'FramesPerTrigger',1,'ReturnedColorSpace','grayscale');

% Create the figure and axes to plot into.
figure('NumberTitle', 'off', 'MenuBar', 'none','Name', 'Titulo da figura');

% Create a spot for the image object display.
res = get(vid, 'ROIPosition');
refJanela = imshow(rand(res(4), res(3), 1));   

%variables handles creation
userdata.refJanela=refJanela; %handle da figura
%parametros para o controlo----------
userdata.variaveis.auxBin=auxBinariza;
userdata.variaveis.auxmargens=auxMargens;
userdata.variaveis.auxTensoes=Tensoes;
userdata.variaveis.contador=1;
userdata.variaveis.centroy=centro;
userdata.variaveis.proporcoes=props;
%------------------------------------
userdata.hao=ao; %handle para o objecto da aquisicao de sinais (motores)
set(vid,'userdata',userdata);

    
    % Start the acquisition.
    start(vid);

    % Avoid peekdata warnings in case it takes too long to return a frame.
    warning off imaq:peekdata:tooManyFramesRequested


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function capturaCallback(vid, event)
% Executed by the videoinput object callback 
% to update the image display and control data values.

% acess to controldata
userdata = get(vid, 'UserData');
ao=userdata.hao;
auxBin=userdata.variaveis.auxBin;
auxMargens=userdata.variaveis.auxmargens;
Tensoes=userdata.variaveis.auxTensoes;
centro=userdata.variaveis.centroy;
props=userdata.variaveis.proporcoes;

% get a frame and eliminate it from memory
frame = peekdata(vid, 1);
if isempty(frame),
    return;
end
flushdata(vid);

%--Image Processing--
bimage = binariza(frame,auxBin);
%bimage = im2bw(frame,0.1); %matlab function - alternative

%--Control processing--
[displayimage motore motord, caso]=controlo(bimage,auxMargens,centro,props);

userdata.variaveis.contador=userdata.variaveis.contador+1;

if userdata.variaveis.contador>10
    %--para fazer o sinal para os motores mais continuo--- 
    actua(ao,motore,motord,Tensoes,caso);%manda sinal aos motores     
    userdata.variaveis.contador=10;
end

% data actualization---
userdata.image = displayimage;
set(vid, 'UserData', userdata);

% If the figure has been destroyed on us, stop the acquisition.
if ~ishandle(userdata.refJanela),
    putdata(ao,[0 0]);
    start(ao);
    pause(0.01);
    stop(ao);
    stop(vid);
    return;
end

% Update the figure display with the latest data.
set(userdata.refJanela, 'CData',userdata.image );
drawnow;


