% funo que binariza e permite visualizar a imagem binarizada para efeitos
% de teste ao parametro auxiliar de binarizao
%testebin(auxBinariza)
%Inputs:
%auxBinariza--> parametro auxiliar de binarizao
%Build by Gonalo Madeira Out2004
function testebin(auxBinariza)

% Configure the video input object to continuously acquire data.
delete(imaqfind)
vid = videoinput('winvideo',1);
triggerconfig(vid, 'manual');
set(vid, 'Tag', 'Teste prog','TimerFcn', @captura, 'TimerPeriod',...
    0.01,'FramesPerTrigger',1,'ReturnedColorSpace','grayscale');

% Create the figure and axes to plot into.
figure('NumberTitle', 'off', 'MenuBar', 'none','Name', 'Titulo da figura');

% Create a spot for the image object display.
res = get(vid, 'ROIPosition');
refJanela = imshow(rand(res(4), res(3), 1));   

%variables handles creation
userdata.refJanela=refJanela; %handle da figura
userdata.variaveis=auxBinariza; %variaveis introduzidas pela aplicao
set(vid,'userdata',userdata)

    % Start the acquisition.
    start(vid);

    % Avoid peekdata warnings in case it takes too long to return a frame.
    warning off imaq:peekdata:tooManyFramesRequested

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function captura(vid, event)
% Executed by the videoinput object callback 
% to update the image display and control data values.

% acess to controldata
userdata = get(vid, 'UserData');
auxBin=userdata.variaveis;

% get a frame and eliminate it from memory
frame = peekdata(vid, 1);
if isempty(frame),
    return;
end
flushdata(vid);

%--Image Processing--
bimage = binariza(frame,auxBin);
%bimage = im2bw(frame,0.1); %matlab function - alternative

% data actualization---
userdata.image = bimage;
set(vid, 'UserData', userdata);

% If the figure has been destroyed on us, stop the acquisition.
if ~ishandle(userdata.refJanela),
    stop(vid);
    return;
end

% Update the figure display with the latest data.
set(userdata.refJanela, 'CData',userdata.image );
drawnow;
